Dim DEBUG
DEBUG = False

Set FSO = CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")

' read parameters
BFPath =  WScript.Arguments(0)  ' path to bogofilter.exe
BFPath = Mid(BFPath, 2, Len(BFPath) - 2) ' remove leading and trailing "'"
File =  WScript.Arguments(1) ' file for testing
UAccount =  WScript.Arguments(2) '  i.e. "user@dom"

If DEBUG Then
	DebugOutput "DEBUG: " & "BFPath=" & BFPath
	DebugOutput "DEBUG: " & "File=" & File
	DebugOutput "DEBUG: " & "UAccount=" & UAccount
End If

' initialize variables
fffile = FSO.GetFileName(File)

UserDom = ""
UserName = ""

UserNameDom = Split(UAccount, "@")

If UBound(UserNameDom, 1) > 0 Then
	UserName = UserNameDom(0)
	UserDom = UserNameDom(1)
Else
	UserName = UAccount
	UserDom = ""
End If

LOGS = FSO.BuildPath(WshShell.RegRead("HKLM\SOFTWARE\AfterLogic\XMail\MAIL_ROOT"), "\logs\")
RDB = FSO.BuildPath(WshShell.RegRead("HKLM\SOFTWARE\AfterLogic\XMail\MAIL_ROOT"), "\.SpamDB\wordlist.db")
UBasePath = FSO.BuildPath(WshShell.RegRead("HKLM\SOFTWARE\AfterLogic\XMail\MAIL_ROOT"), "\domains\" & UserDom & "\" & UserName)

out_file = FSO.BuildPath(UBasePath, "Maildir\new\" & fffile)
tmp_file = FSO.BuildPath(UBasePath, "Maildir\tmp\" & fffile & ".spam")

SpamStorageFolder = FSO.BuildPath(UBasePath, "Maildir\.Spam")
DBpath = FSO.BuildPath(UBasePath, ".SpamDB")
File_size = 0
UDB = FSO.BuildPath(DBpath, "wordlist.db")

If DEBUG Then
	DebugOutput "DEBUG: " & "fffile=" & fffile
	
	DebugOutput "DEBUG: " & "UserDom=" & UserDom
	DebugOutput "DEBUG: " & "UserName=" & UserName

	DebugOutput "DEBUG: " & "RDB=" & RDB
	DebugOutput "DEBUG: " & "UBasePath=" & UBasePath

	DebugOutput "DEBUG: " & "out_file=" & out_file
	DebugOutput "DEBUG: " & "tmp_file=" & tmp_file

	DebugOutput "DEBUG: " & "SpamStorageFolder=" & SpamStorageFolder
	DebugOutput "DEBUG: " & "DBpath=" & DBpath
	DebugOutput "DEBUG: " & "UDB=" & UDB
End If


ExitCode=7

' check user spam folder existing
If FSO.FolderExists(DBPath) Then
	DebugOutput Date & " '" & DBPath & "' .SpamDB folder exists, going to check WORDLIST.DB..."
Else
	DebugOutput Date & " '" & DBPath & "' .SpamDB unexists, creating folder to keep WORDLIST.DB..."
	FSO.CreateFolder(DBPath)
End If

' check user database file existing
If FSO.FileExists(UDB) Then
	DebugOutput Date & " '" & UDB & "' WORDLIST.DB file is exist and is not ZERO SIZE, going to check mail..."
Else
	DebugOutput Date & " '" & UDB & "' WORDLIST.DB file is absent or ZERO SIZE, NEED TO LEARN SPAMFILTER before usage, exiting..."
	FSO.CopyFile RDB, UDB
End If

' run bogofilter
If FSO.FileExists(File) Then
	DebugOutput Date & " '" & File & "' exists, going to detect spam level..."
	
	Set objFile = FSO.GetFile(File)
	File_size = objFile.Size

	' copy only source message data to temp file
	Set readStream = FSO.OpenTextFile(File, 1, False, -2)
	Set writeStream = FSO.OpenTextFile(tmp_file, 2, True, -2)

	NeedWrite = False
	Do While readStream.AtEndOfStream <> True
		readLine = readStream.ReadLine
		writeStream.WriteLine(readLine)
	Loop
	
	writeStream.Close()
	readStream.Close()

	' remove incoming file
	FSO.DeleteFile File, True

	WshShell.Run """" & BFPath & """ -p --spam-header-name=""X-Spam-Header"" -I """ & tmp_file & """ -O """ & File & """ -d """ & DBPath & """", 0, True
	
	DebugOutput "RUN: """ & BFPath & """ -p --spam-header-name=""X-Spam-Header"" -I """ & tmp_file & """ -O """ & out_file & """ -d """ & DBPath & """"

	' remove temp file
	FSO.DeleteFile tmp_file, True
	
	DebugOutput Date & "Inspected:" & File _
		& "	Size:" & File_size _
		& "	Account:" & UAccount _
		& "	Database:" & DBpath
	ExitCode = 7
Else
	DebugOutput Date & " '" & File & "' unexists, going to exit..."
	ExitCode = 3
End If

DebugOutput Date & " Spamfilter ends analise..."
WScript.Quit(ExitCode)

Sub DebugOutput(str)
	If DEBUG Then
		LogPath = FSO.BuildPath(LOGS, "spamfilter-detect-DEBUG-" & Date & ".log")
		Set writeStream = FSO.OpenTextFile(LogPath, 8, True, -2)
		writeStream.WriteLine(str)
		writeStream.Close()
	End If
	WScript.Echo str
End Sub

